//=============================================================================
// TriadRedArrow.
//=============================================================================
class RedArrowZymeDealer12 extends NewScriptedPawnTest;

Var Name PrevAlliance;
Var DeusExPlayer PrevAllianceGuy;
Var DeusExPlayer P;
Var bool Zyme;
Var int OnMessage;
Var bool bBought;
Var class<DeusExPickup> ItemForTransfer;
Var BarkBulk B;

function TakeDamageBase(int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType,
                        bool bPlayAnim)
{
	Super.TakeDamageBase(Damage, instigatedBy, hitlocation, momentum, damageType, bPlayAnim);
	P = None;
	SetTimer(0.0, false);
}

function Carcass SpawnCarcass()
{
	local RAZ1Spawner2 RAZ12;

	IsKilled(Enemy);

	foreach AllActors(class'RAZ1Spawner2',RAZ12)
	{
		RAZ12.SetTimer(90.0, false);
	}			

	return Super.SpawnCarcass();
}


function IsKilled(pawn Killer)
{
	local WeaponAssaultGun MPBW;
	local CozCreditCard ccc;

	if (Killer.IsA('Human'))
	{
		if(Killer.Skin == Texture'DeusExCharacters.Skins.TriadLumPathTex1')
		{
			Human(Killer).Credits+=50;
			Human(Killer).ClientMessage("|p750 credits earned.");
			Human(Killer).SkillPointsAdd(150);
		}
		else if(Killer.Skin == Texture'DeusExCharacters.Skins.TriadRedArrowTex0')
		{
			Human(Killer).ClientMessage("|p2 400 CREDITS LOST.");
			Human(Killer).ClientMessage("|p2 You could get in trouble with your gang. Be careful.");

			if(Human(Killer).Credits >= 100)
			{
				Human(Killer).Credits -= 100;
			}
			else
			{
				Human(Killer).Credits = 0;
			}
		}
		else
		{
			Human(Killer).SkillPointsAdd(100);

			foreach AllActors(class'CozCreditCard',ccc)
			{
				if(ccc.Owner == Human(Killer))
				{
					if(ccc.bOnLPRecMission == True)
					{
						ccc.bOnLPRecMission = False;
						ccc.bKilledRADealers = True;
					}
				}
			}
		}
	}

	foreach AllActors(class'WeaponAssaultGun',MPBW)
	{
		if(MPBW.Owner == Self)
		{
			MPBW.Destroy();
		}
	}
}

function Frob(Actor Frobber, Inventory frobWith) 
{
	local DeusExPickup Zymeee;

	if(P == None)
	{
		P=DeusExPlayer(Frobber);
		SetTimer(1.8, true);
		OnMessage = 0;
	}
	else
	{
		if(P != DeusExPlayer(Frobber))
		{
			DeusExPlayer(Frobber).ClientMessage("|p1Zyme Dealer: Hold on...");
		}

		if(Zyme == True)
		{
			if(DeusExPlayer(Frobber) == P)
			{
				if(P.Credits >= 250)
				{
					P.Credits -= 250;
					Zymeee = Spawn( ItemForTransfer,,,Location + (CollisionRadius+ItemForTransfer.Default.CollisionRadius+30) * Vector(Rotation) + vect(0,0,1) * 15 );
					bBought = True;
					Zymeee.RespawnTime = 0.0;
				}
				else
				{
					P.ClientMessage("|p1Zyme Dealer: You haven't got c250 on you? Come back with it.");
					P = None;
					SetTimer(0.0, false);
					OnMessage = 0;
					Zyme = false;
				}
			
			}
			else
			{
				DeusExPlayer(Frobber).ClientMessage("|p1Zyme Dealer: Hold on...");
			}
		}
	}
}

function Timer()
{
	local DeusExRootWindow rootwindow;

	rootwindow = DeusExRootWindow(P.rootwindow);

	if(P != None)
	{
		if(OnMessage == 0)
		{
			P.ClientMessage("|p1Zyme Dealer: You seem okay. Want some red zyme?");
			SetTimer(2.0, true);
		}

		if(OnMessage == 1)
		{
			P.ClientMessage("|p7You: Red zyme?");
		}

		if(OnMessage == 2)
		{
			P.ClientMessage("|p1Zyme Dealer: It makes you stronger; good for melee. c250 a vial.");
			P.ClientMessage("|p7 (Right click again quickly to buy Red Zyme for 250)");
			Zyme = True;
			SetTimer(4.0, true);
		}

		if(OnMessage == 3)
		{
			if(bBought == false)
			{
				P.ClientMessage("|p1Zyme Dealer: Fine; carry on.");
			}
			else
			{
				bBought=false;
			}

			P = None;
			SetTimer(0.0, false);
			OnMessage = 0;
			Zyme = false;
		}
		OnMessage += 1;
	}
}

function Tick(float deltaTime)
{
	// Keep turning towards the person we're speaking to
	if (P != None)
	{
		LookAtActor(P, true, true, true, 0, 0.5);
		LipSynch(deltaTime);
	}

	Super.Tick(deltatime);
}

defaultproperties
{
     NNAlliance=DDEnemy
     InitialAlliances(0)=(AllianceName=DDEnemy,AllianceLevel=-1.000000,bPermanent=True)
     AttitudeToPlayer=ATTITUDE_Hate
     bCAggressive=True
     ItemForTransfer=Class'Cozmo_RPG_Pack.ZymeRed'
     CarcassType=Class'DeusEx.TriadRedArrowCarcass'
     Orders=Standing
     WalkingSpeed=0.300000
     BaseAssHeight=-23.000000
     InitialInventory(0)=(Inventory=Class'DeusEx.WeaponAssaultGun')
     InitialInventory(1)=(Inventory=Class'DeusEx.Ammo762mm',Count=100)
     walkAnimMult=1.200000
     GroundSpeed=200.000000
     WaterSpeed=240.000000
     AirSpeed=144.000000
     BaseEyeHeight=36.000000
     DrawType=DT_Mesh
     Texture=Texture'DeusExCharacters.Skins.TriadRedArrowTex0'
     Skin=Texture'DeusExCharacters.Skins.TriadRedArrowTex0'
     Mesh=LodMesh'DeusExCharacters.GM_Trench'
     HealthHead=150
     HealthTorso=150
     HealthLegLeft=150
     HealthLegRight=150
     HealthArmLeft=150
     HealthArmRight=150
     MultiSkins(0)=Texture'DeusExCharacters.Skins.TriadRedArrowTex0'
     MultiSkins(1)=Texture'DeusExCharacters.Skins.TriadRedArrowTex2'
     MultiSkins(2)=Texture'DeusExCharacters.Skins.MaxChenTex3'
     MultiSkins(3)=Texture'DeusExCharacters.Skins.TriadRedArrowTex0'
     MultiSkins(4)=Texture'DeusExCharacters.Skins.MaxChenTex1'
     MultiSkins(5)=Texture'DeusExCharacters.Skins.TriadRedArrowTex2'
     MultiSkins(6)=Texture'DeusExCharacters.Skins.FramesTex3'
     MultiSkins(7)=Texture'DeusExItems.Skins.BlackMaskTex'
     CollisionRadius=14.000000
     CollisionHeight=47.500000
     Buoyancy=97.000000
     BindName="Red Arrow Elite"
     FamiliarName="Zyme Dealer"
     UnfamiliarName="Zyme Dealer"
}
